$(function () {
    $("#meteo").hide();
    $("#search").on("keyup", function (event) {
        // dtction de la touche "enter" du clavier
        var charCode = (event.which) ? event.which : event.keyCode;
        if (charCode == 13) {
            chooseCity();
        }
    });
    $("#selectDestination").on("change", "select", function () {
        getWikiPage();
        getWeather();
        getNews();
    });
})

function chooseCity(){
    var search = $("#search").val();
    if (search.length < 2) return;
    $.getJSON("http://api.geonames.org/searchJSON?maxRows=10&featureClass=P&lang=fr&username=techweb&callback=?", {"name": search}, function (data) {
        var nbResults = data.totalResultsCount;
        var select = $("<select>");
        $.each(data.geonames, function (i, place){
            var opt = $("<option>").text(place.name + " (" + place.countryName + ")");
            opt.data("lat", place.lat);
            opt.data("lng", place.lng);
            opt.data("name", place.name);
            select.append(opt);
        });
        if (nbResults > 0) {
            $("#selectDestination").empty().append(select);
            $("#selectDestination select").trigger("change");
        } else {
            $("#meteo").hide();
            $("#wiki, #news, #selectDestination").empty();
        }
    })
}

function getWikiPage() {
    var opt = $("#selectDestination :selected");
    $.get("geoNameWiki.php", {
        lat: opt.data("lat"),
        lng: opt.data("lng")
    }, function (xml) {
        // boucle sur les page wiki
        var results = $("<ul>");
        $("entry", xml).each(function (i, entry){
            var title = $("title", entry).text();
            var url = $("wikipediaUrl", entry).text();
            var li = $("<li>");
            var link = $("<a>").attr('href', url).attr("target", "_blank").text(title);
            li.append(link).appendTo(results);
        });
        $("#wiki").empty().append(results);
    });
}

function getWeather(){
    var opt = $("#selectDestination :selected");
    // météo
    $.getJSON("http://api.geonames.org/findNearByWeatherJSON?username=techweb&lang=fr&callback=?", {
        lat: opt.data("lat"),
        lng: opt.data("lng")
    }, function (data) {
        $("#meteo").show();
        $("#temp").text(data.weatherObservation.temperature);
        // conversion des noeuds de la vitesse du vent
        $("#wind").text(Math.round(1.852 * data.weatherObservation.windSpeed));
        $("#clouds").text(data.weatherObservation.clouds);
        $("#humidity").text(data.weatherObservation.humidity);
    })
}

function getNews(){
    var opt = $("#selectDestination :selected");
    //news
    $.get("googleNews.php", {
        placename: opt.data("name")
    }, function(xml){
        // boucle sur les pages de news
        var results = $("<ul>");
        $("item", xml).each(function (i, entry){
            var title = $("title", entry).text();
            var url = $("link", entry).text();
            var li = $("<li>");
            var link = $("<a>").attr('href', url).attr("target", "_blank").text(title);
            li.append(link).appendTo(results);
        })
        $("#news").empty().append(results);
    });
}
